//===========================================================================
//                                                          CELLULAR AUTOMATA
//                                                            ONE DIMENSIONAL
//===========================================================================
//   Given a 3-cell neighborhood,
//   there are 14 possible rules for a birth:
//     1) 0 neighbors
//     2) 1 neighbor
//     3) 2 neighbors
//     4) 3 neighbors
//     5) 0 or 1 neighbors
//     6) 0 or 2 neighbors
//     7) 0 or 3 neighbors
//     8) 1 or 2 neighbors
//     9) 1 or 3 neighbors
//    10) 2 or 3 nieghbors
//    11) 0 or 1 or 2 neighbors
//    12) 0 or 1 or 3 neighbors
//    13) 0 or 2 or 3 neighbors
//    14) 1 or 2 or 3 neighbors
//    15) 0 or 1 or 2 or 3 neighbors is a trivial case
//  For less than 3 conditions, duplicate the settings in the ComboBoxes
//  For instance, set "0 or 1" as "001" or "110" etc...
//===========================================================================

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

//================================================================= VARIABLES
int generation = 0;
int parent[500], child[500];
int count;
int orA, orB, orC;

//================================================================= FUNCTIONS

//---------------------------------------------------------- Randomize Parent
void randomizeParent (void) {
   for (int i = 0; i < 500; i++) {
      parent[i] = random(2);
   }
}

//---------------------------------------------------------------- Initialize
void initialize (void) {
   Randomize();
   Form1->Refresh();
   generation = 0;
   Form1->EditGeneration->Text = generation;
   randomizeParent();
}

//----------------------------------------------------------------------- Run
void run (void) {
   initialize();
   orA = Form1->ComboBox1->ItemIndex;
   orB = Form1->ComboBox2->ItemIndex;
   orC = Form1->ComboBox3->ItemIndex;
   for (int i = 0; i < 500; i++) {
      generation ++;
      Form1->EditGeneration->Text = generation;
                                                // calculate child generation
                                                   //  from parent generation
      for (int i = 0; i < 500; i++) {
                                                           // count neighbors
         if (i == 0) count = parent[499] + parent[i] + parent[i+1];
         else if (i == 499) count = parent[i-1] + parent[i] + parent[0];
         else count = parent[i-1] + parent[i] + parent[i+1];
                                                                // apply rule
         if (count == orA || count == orB || count == orC ) child[i] = 1;
         else child[i] = 0;
                                                     // draw child generation
         if (child[i]) Form1->Canvas->Pixels[i][generation] = clYellow;
         else Form1->Canvas->Pixels[i][generation] = clBlack;
      }
                                                  // child generation becomes
                                                    // next parent generation
      for (int i = 0; i<500; i++) {
         parent[i] = child[i];
      }

   Application->ProcessMessages();
   }
}

//============================================================ EVENT HANDLERS

//---------------------------------------------------------------- Run Button
void __fastcall TForm1::ButtonRunClick(TObject *Sender)
{
   run();
}

